#version 430

layout (points) in; // points in

layout (triangle_strip, max_vertices = 4) out; // quads out

uniform mat4 ProjectionMatrix;

in vData { float TTL1; 
} vertex[]; // from vertex shader

out vec2 TexCoord0;

flat out float TTL0; //flat: no interpolation between vertices

void main (void) {



float TTL = vertex[0].TTL1 * 0.2;


const vec2 size = vec2(40 * TTL, 40* TTL);



vec4 P = gl_in[0].gl_Position; // position in view-space

vec2 va = P.xy + vec2(-0.5, -0.5) * size; // bottom-leftcorner
vec4 swag = ProjectionMatrix * vec4(va, P.zw);
gl_Position = swag;
TexCoord0 = vec2(0.0, 0.0);
TTL0 = vertex[0].TTL1;
EmitVertex();
 
vec2 vd = P.xy + vec2(0.5, -0.5) * size;
swag = ProjectionMatrix * vec4(vd, P.zw);
gl_Position = swag;
TexCoord0 = vec2(1.0, 0.0);
TTL0 = vertex[0].TTL1;
EmitVertex();  


vec2 vb = P.xy + vec2(-0.5, 0.5) * size;
swag = ProjectionMatrix * vec4(vb, P.zw);
gl_Position = swag;
TexCoord0 = vec2(0.0, 1.0);
TTL0 = vertex[0].TTL1;
EmitVertex();    
  

vec2 vc = P.xy + vec2(0.5, 0.5) * size;
swag = ProjectionMatrix * vec4(vc, P.zw);
gl_Position = swag;

TexCoord0 = vec2(1.0, 1.0);
TTL0 = vertex[0].TTL1;
EmitVertex();  

EndPrimitive();
}